diff --git a/src/libcharon/network/socket.h b/src/libcharon/network/socket.h
index b4062f8a0..cc3b1beca 100644
--- a/src/libcharon/network/socket.h
+++ b/src/libcharon/network/socket.h
@@ -17,6 +17,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup socket socket
  * @{ @ingroup network
@@ -61,6 +83,11 @@ enum socket_family_t {
 	 * Both address families supported
 	 */
 	SOCKET_FAMILY_BOTH = (1 << 2) - 1,
+
+	/**
+	 * FC BSG
+	 */
+	SOCKET_FAMILY_FC = (1 << 2),
 };
 
 /**
diff --git a/src/libcharon/network/socket_manager.c b/src/libcharon/network/socket_manager.c
index 2b2a05702..f495a1455 100644
--- a/src/libcharon/network/socket_manager.c
+++ b/src/libcharon/network/socket_manager.c
@@ -15,12 +15,35 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "socket_manager.h"
 
 #include <daemon.h>
 #include <threading/thread.h>
 #include <threading/rwlock.h>
 #include <collections/linked_list.h>
+#include <collections/hashtable.h>
 
 typedef struct private_socket_manager_t private_socket_manager_t;
 
@@ -35,15 +58,20 @@ struct private_socket_manager_t {
 	socket_manager_t public;
 
 	/**
-	 * List of registered socket constructors
+	 * List of socket constructors used during shutdown.
 	 */
-	linked_list_t *sockets;
+	hashtable_t *socket_constructors;
 
 	/**
-	 * Instantiated socket implementation
+	 * Instantiated socket implementation for IP
 	 */
 	socket_t *socket;
 
+	/**
+	 * Instantiated socket implementation for FC
+	 */
+	socket_t *fc_socket;
+
 	/**
 	 * The constructor used to create the current socket
 	 */
@@ -77,26 +105,51 @@ METHOD(socket_manager_t, sender, status_t,
 	private_socket_manager_t *this, packet_t *packet)
 {
 	status_t status;
+	socket_t *selected_socket = NULL;
+	
 	this->lock->read_lock(this->lock);
-	if (!this->socket)
+	host_t *src = packet->get_source (packet);
+	int family = src->get_family (src);
+	
+	if (family == AF_NETLINK)
 	{
-		DBG1(DBG_NET, "no socket implementation registered, sending failed");
+		selected_socket = this->fc_socket;
+	}
+	else
+	{
+		selected_socket = this->socket;
+	}
+	
+	if (!selected_socket)
+	{
+		DBG1(DBG_NET, "no socket implementation registered for family %d, sending failed", family);
 		this->lock->unlock(this->lock);
 		return NOT_SUPPORTED;
 	}
-	status = this->socket->send(this->socket, packet);
+	status = selected_socket->send(selected_socket, packet);
 	this->lock->unlock(this->lock);
 	return status;
 }
 
 METHOD(socket_manager_t, get_port, uint16_t,
-	private_socket_manager_t *this, bool nat_t)
+	private_socket_manager_t *this, socket_family_t family, bool nat_t)
 {
 	uint16_t port = 0;
+	socket_t *selected_socket;
+	
 	this->lock->read_lock(this->lock);
-	if (this->socket)
+	if (family == SOCKET_FAMILY_FC)
+	{
+		selected_socket = this->fc_socket;
+	}
+	else
 	{
-		port = this->socket->get_port(this->socket, nat_t);
+		selected_socket = this->socket;
+	}
+	
+	if (selected_socket)
+	{
+		port = selected_socket->get_port(selected_socket, nat_t);
 	}
 	this->lock->unlock(this->lock);
 	return port;
@@ -106,40 +159,58 @@ METHOD(socket_manager_t, supported_families, socket_family_t,
 	private_socket_manager_t *this)
 {
 	socket_family_t families = SOCKET_FAMILY_NONE;
-	this->lock->read_lock(this->lock);
-	if (this->socket)
+
+	// Supported families is not needed for fc_socket because there is only one
+	// family for FC, i.e. no IPv4 and IPv6.
+	if (this->socket != NULL)
 	{
+	this->lock->read_lock(this->lock);
 		families = this->socket->supported_families(this->socket);
+	    this->lock->unlock(this->lock);
 	}
-	this->lock->unlock(this->lock);
 	return families;
 }
 
-static void create_socket(private_socket_manager_t *this)
+METHOD(socket_manager_t, add_socket, void,
+	private_socket_manager_t *this, socket_constructor_t create)
 {
-	socket_constructor_t create;
-	/* remove constructors in order to avoid trying to create broken ones
-	 * multiple times */
-	while (this->sockets->remove_first(this->sockets,
-									   (void**)&create) == SUCCESS)
+	socket_t *new_socket;
+	socket_family_t family;
+	
+	this->lock->write_lock(this->lock);
+	new_socket = create();
+	family = new_socket->supported_families (new_socket);
+	
+	if (family == SOCKET_FAMILY_FC)
+	{
+		if (this->fc_socket)
+		{
+			DBG0(DBG_NET, "Attempting to create second FC-SP socket!  Ignoring second socket.");
+			DESTROY_IF (new_socket);
+			new_socket = NULL;
+		}
+		else
+		{
+			this->fc_socket = new_socket;
+		}
+	}
+	else
 	{
-		this->socket = create();
 		if (this->socket)
 		{
-			this->create = create;
-			break;
+			DBG0(DBG_NET, "Attempting to create second IPsec-SP socket!  Ignoring second socket.");
+			DESTROY_IF (new_socket);
+			new_socket = NULL;
+		}
+		else
+		{
+			this->socket = new_socket;
 		}
 	}
-}
 
-METHOD(socket_manager_t, add_socket, void,
-	private_socket_manager_t *this, socket_constructor_t create)
-{
-	this->lock->write_lock(this->lock);
-	this->sockets->insert_last(this->sockets, create);
-	if (!this->socket)
+	if (new_socket)
 	{
-		create_socket(this);
+		this->socket_constructors->put (this->socket_constructors, (void*) create, (void*) family);
 	}
 	this->lock->unlock(this->lock);
 }
@@ -148,14 +219,20 @@ METHOD(socket_manager_t, remove_socket, void,
 	private_socket_manager_t *this, socket_constructor_t create)
 {
 	this->lock->write_lock(this->lock);
-	this->sockets->remove(this->sockets, create, NULL);
-	if (this->create == create)
+	
+	socket_family_t family = (socket_family_t) this->socket_constructors->get (this->socket_constructors, (void*) create);
+	
+	if (family == SOCKET_FAMILY_FC)
+	{
+		this->fc_socket->destroy (this->fc_socket);
+		this->fc_socket = NULL;
+	}
+	else
 	{
-		this->socket->destroy(this->socket);
+		this->socket->destroy (this->socket);
 		this->socket = NULL;
-		this->create = NULL;
-		create_socket(this);
 	}
+	this->socket_constructors->remove (this->socket_constructors, (void*) create);
 	this->lock->unlock(this->lock);
 }
 
@@ -163,7 +240,7 @@ METHOD(socket_manager_t, destroy, void,
 	private_socket_manager_t *this)
 {
 	DESTROY_IF(this->socket);
-	this->sockets->destroy(this->sockets);
+	DESTROY_IF(this->fc_socket);
 	this->lock->destroy(this->lock);
 	free(this);
 }
@@ -185,8 +262,10 @@ socket_manager_t *socket_manager_create()
 			.remove_socket = _remove_socket,
 			.destroy = _destroy,
 		},
-		.sockets = linked_list_create(),
+		.socket_constructors = hashtable_create (hashtable_hash_ptr, hashtable_equals_ptr, 8),
 		.lock = rwlock_create(RWLOCK_TYPE_DEFAULT),
+		.socket = NULL,
+		.fc_socket = NULL,
 	);
 
 	return &this->public;
diff --git a/src/libcharon/network/socket_manager.h b/src/libcharon/network/socket_manager.h
index add3ffa2c..ee6d1235f 100644
--- a/src/libcharon/network/socket_manager.h
+++ b/src/libcharon/network/socket_manager.h
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup socket_manager socket_manager
  * @{ @ingroup network
@@ -58,7 +80,7 @@ struct socket_manager_t {
 	 * @param nat_t			TRUE to get the port used to float in case of NAT-T
 	 * @return				the port, or 0, if no socket is registered
 	 */
-	uint16_t (*get_port)(socket_manager_t *this, bool nat_t);
+	uint16_t (*get_port)(socket_manager_t *this, socket_family_t family, bool nat_t);
 
 	/**
 	 * Get the address families the registered socket is listening on.
diff --git a/src/libcharon/plugins/auth_els/Makefile.am b/src/libcharon/plugins/auth_els/Makefile.am
new file mode 100644
index 000000000..5bb04d3da
--- /dev/null
+++ b/src/libcharon/plugins/auth_els/Makefile.am
@@ -0,0 +1,25 @@
+AM_CPPFLAGS = \
+	-I$(top_srcdir)/src/libstrongswan \
+	-I$(top_srcdir)/src/libhydra \
+	-I$(top_srcdir)/src/libcharon
+
+AM_CFLAGS = \
+	$(PLUGIN_CFLAGS)
+
+if MONOLITHIC
+noinst_LTLIBRARIES = libstrongswan-auth-els.la
+else
+plugin_LTLIBRARIES = libstrongswan-auth-els.la
+endif
+
+libstrongswan_auth_els_la_SOURCES = \
+	auth_els_configs.h auth_els_configs.c \
+	auth_els_kernel_fc_sp.h auth_els_kernel_fc_sp.c \
+	auth_els_ike.h auth_els_ike.c \
+	auth_els_socket.h auth_els_socket.c \
+	auth_els_plugin.h auth_els_plugin.c \
+	auth_els_utils.h
+
+libstrongswan_auth_els_la_LDFLAGS = -module -avoid-version
+
+
diff --git a/src/libcharon/plugins/auth_els/auth_els_configs.c b/src/libcharon/plugins/auth_els/auth_els_configs.c
new file mode 100644
index 000000000..5a0a0e9c6
--- /dev/null
+++ b/src/libcharon/plugins/auth_els/auth_els_configs.c
@@ -0,0 +1,183 @@
+/* Copyright (C) 2019-2022 Marvell */
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <dirent.h>
+#include <signal.h>
+#include <errno.h>
+
+#ifdef AUTH_ELS_KMIP	// If we are not compiling KMIP, then don't want these
+#include <openssl/bio.h>
+#endif
+
+#include <collections/linked_list.h>
+#include <threading/thread.h>
+#include <threading/condvar.h>
+#include <threading/mutex.h>
+#include <processing/jobs/callback_job.h>
+#include <credentials/keys/shared_key.h>
+#include <utils/identification.h>
+#include <collections/hashtable.h>
+
+#include <config/child_cfg.h>
+
+#include "auth_els_configs.h"
+#include "auth_els_utils.h"
+
+#define DEFAULT_REAUTH_REKEY_JITTER 30 // minimum time between reauth and rekey
+#define CONFIG_LIMIT_OVERRIDE_LIMITS_COOKIE 18652001
+
+enum shared_secret_type_t {
+	SHARED_SECRET_TYPE_WWPN,
+	SHARED_SECRET_TYPE_CONFIG_FILE,
+	SHARED_SECRET_TYPE_KMIP,
+};
+
+struct private_auth_els_configs_t {
+
+	auth_els_configs_t public;
+
+	unsigned int reauth_rekey_jitter;
+	bool override_limits;				// Allows overriding of minimum reauth_time and rekey_time
+	
+	chunk_t shared_secret;
+	enum shared_secret_type_t secret_type;
+	
+	proposal_t *esp_proposal;
+	proposal_t *ike_proposal;
+	bool vmware;
+};
+typedef struct private_auth_els_configs_t private_auth_els_configs_t;
+
+METHOD(auth_els_configs_t, reload_config, bool,
+	private_auth_els_configs_t *this)
+{
+	char *remote, *wwpn, *disabled_remote;
+	int wwpn_len = 0, index = 0, j = 0;
+	int cookie;
+	char *rekey;
+
+	enumerator_t* enumerator = lib->settings->create_section_enumerator(lib->settings,
+									"%s.plugins.auth-els.disabled_remotes", lib->ns);
+
+	while (enumerator->enumerate(enumerator, &remote))
+	{
+		DBG2(DBG_CFG, "disabled remotes: %s", remote);
+		wwpn = lib->settings->get_str(lib->settings,
+							"%s.plugins.auth-els.disabled_remotes.%s.wwpn", NULL,
+							lib->ns, remote);
+		if (wwpn == NULL)
+		{
+			DBG2(DBG_CFG, "disabled remotes NOT found in auth-els.conf");
+			continue;
+		}
+		DBG2(DBG_CFG, "disabled remote port for auth from conf '%s'", wwpn);
+		wwpn_len = strlen(wwpn) + 1;
+		disabled_remote = (char*)malloc(wwpn_len);
+		memset(disabled_remote, 0, wwpn_len);
+		for (index = 0, j = 0; index < strlen(wwpn); index++)
+		{
+			if (wwpn[index] == ':')
+				continue;
+			if (wwpn[index] == '-')
+				continue;
+			if (wwpn[index] == '.')
+				continue;
+			if (wwpn[index] == ' ')
+				continue;
+
+			disabled_remote[j++] = wwpn[index];
+			if (index == (strlen(wwpn) - 1))
+				disabled_remote[j] = '\0';
+		}
+
+
+		if(j > 0)
+		{
+
+		}
+		else
+		{
+			free (disabled_remote);
+		}
+	}
+	enumerator->destroy(enumerator);
+
+	enumerator = lib->settings->create_section_enumerator(lib->settings,
+			"%s.plugins.auth-els.rekey_config", lib->ns);
+
+	while (enumerator->enumerate(enumerator, &rekey))
+	{
+		this->reauth_rekey_jitter = lib->settings->get_int(lib->settings,
+				"%s.plugins.auth-els.rekey_config.%s.reauth_rekey_jitter", DEFAULT_REAUTH_REKEY_JITTER,
+				lib->ns, rekey);
+		
+		cookie = lib->settings->get_int(lib->settings,
+				"%s.plugins.auth-els.rekey_config.%s.override_lower_limits", 0,
+				lib->ns, rekey);
+		
+		if (cookie == CONFIG_LIMIT_OVERRIDE_LIMITS_COOKIE)
+		{
+			this->override_limits = true;
+		}
+	}
+	enumerator->destroy(enumerator);
+
+	int sender_thread_count = lib->settings->get_int(lib->settings,
+									"%s.sender_thread_count", 1, lib->ns);
+	
+	this->vmware = lib->settings->get_bool(lib->settings,
+					"%s.plugins.auth-els.vmware", FALSE, lib->ns);
+
+	DBG_STD ("config setting of reauth_rekey_jitter: %d, override_limits: %d, sender_thread_count: %d",
+					this->reauth_rekey_jitter, this->override_limits, sender_thread_count);
+	
+	return TRUE;
+}
+
+METHOD(auth_els_configs_t, get_vmware, bool,
+	private_auth_els_configs_t *this)
+{
+	return this->vmware;
+}
+
+METHOD(auth_els_configs_t, get_reauth_rekey_jitter, unsigned int,
+	private_auth_els_configs_t *this)
+{
+	return this->reauth_rekey_jitter;
+}
+
+METHOD(auth_els_configs_t, get_override_limits, bool,
+	private_auth_els_configs_t *this)
+{
+	return this->override_limits;
+}
+
+METHOD(auth_els_configs_t, destroy, void,
+	private_auth_els_configs_t *this)
+{
+	DBG_ENTER;
+	
+	free(this);
+}
+
+auth_els_configs_t *auth_els_configs_create()
+{
+	private_auth_els_configs_t *this;
+
+	INIT(this,
+		.public = {
+			.destroy = _destroy,
+			.reload_config = _reload_config,
+			.get_reauth_rekey_jitter = _get_reauth_rekey_jitter,
+			.get_override_limits = _get_override_limits,
+			.get_vmware = _get_vmware,
+		},
+		.override_limits = false,
+		.vmware = false,
+	);
+	
+	return &(this->public);
+}
diff --git a/src/libcharon/plugins/auth_els/auth_els_configs.h b/src/libcharon/plugins/auth_els/auth_els_configs.h
new file mode 100644
index 000000000..184651da2
--- /dev/null
+++ b/src/libcharon/plugins/auth_els/auth_els_configs.h
@@ -0,0 +1,41 @@
+/* Copyright (C) 2019-2020 Marvell */
+
+/**
+ * @defgroup auth_els auth_els
+ * @ingroup cplugins
+ *
+ * @defgroup auth_els_configs auth_els_configs
+ * @{ @ingroup auth_els
+ */
+
+#ifndef AUTH_ELS_CONFIGS_H_
+#define AUTH_ELS_CONFIGS_H_
+
+#include <credentials/credential_set.h>
+#include <daemon.h>
+
+// ESP proposal default
+#define ESP_ENCR_PROPOSAL_DEFAULT_128_BIT    "aes128gcm16"
+
+// IKE proposal default
+#define IKE_PROPOSAL_DEFAULT_128_BIT         "aes128gcm16-prfsha256-curve25519"
+
+#define HOST_NAME_SIZE          16
+#define HOST_ID_SIZE            4
+#define REMOTE_PORT_ID_SIZE     4
+#define PEER_NAME_SIZE          33
+
+typedef struct auth_els_configs_t auth_els_configs_t;
+struct auth_els_configs_t {
+
+	bool (*reload_config)(auth_els_configs_t *this);
+    unsigned int (*get_reauth_rekey_jitter)(auth_els_configs_t *this);
+    bool (*get_override_limits)(auth_els_configs_t *this);
+    bool (*get_vmware) (auth_els_configs_t *this);
+        
+	void (*destroy)(auth_els_configs_t *this);
+};
+
+auth_els_configs_t *auth_els_configs_create();
+
+#endif /** AUTH_ELS_CONFIGS_H_ @}*/
diff --git a/src/libcharon/plugins/auth_els/auth_els_ike.c b/src/libcharon/plugins/auth_els/auth_els_ike.c
new file mode 100644
index 000000000..2640469ca
--- /dev/null
+++ b/src/libcharon/plugins/auth_els/auth_els_ike.c
@@ -0,0 +1,270 @@
+/* Copyright (C) 2019-2020 Marvell */
+
+#include <errno.h>
+#include <fcntl.h>
+#include <getopt.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <sys/stat.h>
+#include <sys/time.h>
+#include <sys/ioctl.h>
+#include <scsi/scsi.h>
+#include <scsi/sg.h>
+#include <linux/types.h>
+
+#include <linux/bsg.h>
+#include <sys/socket.h>
+#include <errno.h>
+#include <unistd.h>
+
+#include <scsi/scsi.h>
+#include <scsi/scsi_bsg_fc.h>
+
+#include <sa/ikev2/keymat_v2.h>
+#include <sa/ikev1/keymat_v1.h>
+#include <sa/ikev2/tasks/child_create.h>
+#include <encoding/payloads/nonce_payload.h>
+#include <encoding/payloads/cert_payload.h>
+#include <encoding/payloads/auth_payload.h>
+#include <encoding/payloads/id_payload.h>
+#include <encoding/payloads/sa_payload.h>
+#include <encoding/payloads/ts_payload.h>
+#include <encoding/payloads/ke_payload.h>
+#include <encoding/payloads/notify_payload.h>
+#include <threading/rwlock.h>
+#include <threading/condvar.h>
+#include <threading/mutex.h>
+#include <processing/jobs/rekey_ike_sa_job.h>
+#include <processing/jobs/rekey_child_sa_job.h>
+#include <processing/jobs/delete_ike_sa_job.h>
+
+#include "auth_els_ike.h"
+#include "auth_els_socket.h"
+#include "auth_els_utils.h"
+
+/**
+ * Private data of an auth_els_ike_t object.
+ */
+typedef struct private_auth_els_ike_t private_auth_els_ike_t;
+struct private_auth_els_ike_t {
+
+	/**
+	 * Public auth_els_ike_t interface.
+	 */
+	auth_els_ike_t public;
+
+	hashtable_t *fchosts;
+
+};
+
+
+
+METHOD(listener_t, ike_keys, bool,
+	private_auth_els_ike_t *this, ike_sa_t *ike_sa, key_exchange_t *dh,
+	chunk_t dh_other, chunk_t nonce_i, chunk_t nonce_r, ike_sa_t *rekey,
+	shared_key_t *shared, auth_method_t method)
+{    
+	DBG_ENTER;
+
+	return TRUE;
+}
+
+METHOD(listener_t, ike_updown, bool,
+	private_auth_els_ike_t *this, ike_sa_t *ike_sa, bool up)
+{
+	DBG_STD ("enter: up=%s", (up? "yes" : "no"));
+
+	return TRUE;
+}
+
+METHOD(listener_t, ike_rekey, bool,
+	private_auth_els_ike_t *this, ike_sa_t *old, ike_sa_t *new)
+{
+	return TRUE;
+}
+
+
+METHOD(listener_t, child_keys, bool,
+		private_auth_els_ike_t *this, ike_sa_t *ike_sa, child_sa_t *child_sa,
+	bool initiator, key_exchange_t *dh, chunk_t nonce_i, chunk_t nonce_r)
+{
+	DBG_STD ("ike_sa: %p, child_sa: %p", ike_sa, child_sa);
+	
+	return TRUE;
+}
+
+METHOD(listener_t, child_state_change, bool,
+		private_auth_els_ike_t *this, ike_sa_t *ike_sa,
+	child_sa_t *child_sa, child_sa_state_t state)
+{
+	
+	DBG_STD ("ike_sa: %p, child_sa: %p, new state: %N", ike_sa, child_sa, child_sa_state_names, state);
+
+	return TRUE;
+}
+
+METHOD(listener_t, child_updown, bool,
+		private_auth_els_ike_t *this, ike_sa_t *ike_sa,
+		child_sa_t *child_sa,  bool up)
+{
+	DBG_ENTER;
+	
+	return TRUE;
+}
+
+METHOD(listener_t, child_rekey, bool,
+		private_auth_els_ike_t *this, ike_sa_t *ike_sa,
+		child_sa_t *old, child_sa_t *new)
+{
+	DBG_STD ("ike_sa: %p, child_sa old: %p, new: %p", ike_sa, old, new);
+
+	return TRUE;
+}
+
+METHOD(listener_t, narrow, bool,
+		private_auth_els_ike_t *this, ike_sa_t *ike_sa,
+		child_sa_t *child_sa, narrow_hook_t type,
+		linked_list_t *local, linked_list_t *remote)
+{
+	DBG_ENTER;
+
+	return TRUE;
+}
+
+METHOD(listener_t, ike_reestablish_pre, bool,
+		private_auth_els_ike_t *this, ike_sa_t *old, ike_sa_t *new)
+{
+	DBG_ENTER;
+	return TRUE;
+}
+
+METHOD(listener_t, ike_reestablish_post, bool,
+		private_auth_els_ike_t *this, ike_sa_t *old, ike_sa_t *new,
+		 bool initiated)
+{
+	DBG_ENTER;
+	return TRUE;
+}
+
+METHOD(listener_t, ike_state_change, bool,
+	private_auth_els_ike_t *this, ike_sa_t *ike_sa, ike_sa_state_t new)
+{
+	DBG_STD ("ike_sa: %p, new_state=%N", ike_sa, ike_sa_state_names, new);
+
+	return TRUE;
+}
+
+METHOD(listener_t, message_hook, bool,
+	private_auth_els_ike_t *this, ike_sa_t *ike_sa, message_t *message,
+	bool incoming, bool plain)
+{
+	DBG_STD ("plain=%s - incoming=%s - request=%s message=%N, message_id initiate: %x, respond: %x",
+			(plain?"true":"false"),
+			(incoming?"true":"false"),
+			(message->get_request(message)?"true":"false"),
+			exchange_type_names, message->get_exchange_type(message), 
+			ike_sa->get_message_id(ike_sa, true), ike_sa->get_message_id(ike_sa, false));
+	
+	return true;
+}
+
+METHOD(listener_t, authorize, bool,
+	private_auth_els_ike_t *this, ike_sa_t *ike_sa,
+	bool final, bool *success)
+{
+	DBG2(DBG_CFG, "auth_els - entering authorize event");
+
+	if (final)
+	{
+		DBG_STD ("final event");
+	}
+
+	*success = TRUE;
+
+	return TRUE; /* stay registered */
+}
+
+
+METHOD(listener_t, alert_hook, bool,
+		private_auth_els_ike_t *this, ike_sa_t *ike_sa, alert_t alert, va_list args)
+{
+	DBG_STD ("enter: alert=%d, ike_sa: %p", alert, ike_sa);
+
+	switch(alert)
+	{
+	case ALERT_SHUTDOWN_SIGNAL:
+		DBG_STD ("AUTH_ELS Plugin shutdown: send app_stop to all hosts now.");
+		break;
+		
+	case ALERT_KEEP_ON_CHILD_SA_FAILURE:
+	case ALERT_RETRANSMIT_SEND_TIMEOUT:
+	case ALERT_HALF_OPEN_TIMEOUT:		
+	case ALERT_PEER_INIT_UNREACHABLE:
+	case ALERT_LOCAL_AUTH_FAILED:
+	case ALERT_PEER_AUTH_FAILED:
+	case ALERT_PEER_ADDR_FAILED:
+	case ALERT_PARSE_ERROR_HEADER:
+	case ALERT_PARSE_ERROR_BODY:
+	case ALERT_PROPOSAL_MISMATCH_IKE:
+	case ALERT_PROPOSAL_MISMATCH_CHILD:
+	case ALERT_TS_MISMATCH:
+	case ALERT_INSTALL_CHILD_SA_FAILED:
+	case ALERT_INSTALL_CHILD_POLICY_FAILED:
+	case ALERT_AUTHORIZATION_FAILED:
+	case ALERT_RETRANSMIT_RECEIVE:
+	
+	case ALERT_INVALID_IKE_SPI:
+	case ALERT_TS_NARROWED:
+	case ALERT_RETRANSMIT_SEND:
+	case ALERT_IKE_SA_EXPIRED:
+	default:
+		break;
+	};
+
+	return TRUE;
+}
+
+METHOD(auth_els_ike_t, destroy, void,
+	private_auth_els_ike_t *this)
+{
+	DBG2(DBG_CFG, "auth_els_ike: destroy");
+
+	free(this);
+}
+
+/**
+ * See header
+ */
+auth_els_ike_t *auth_els_ike_create()
+{
+	DBG2(DBG_CFG, "In auth_els_ike_create");
+
+	private_auth_els_ike_t *this;
+
+	INIT(this,
+		.public = {
+			.listener = {
+				.ike_keys = _ike_keys,
+				.ike_updown = _ike_updown,
+				.ike_rekey = _ike_rekey,
+				.ike_state_change = _ike_state_change,
+				.message = _message_hook,
+				.authorize = _authorize,
+				.alert = _alert_hook,
+				.ike_reestablish_pre = _ike_reestablish_pre,
+				.ike_reestablish_post = _ike_reestablish_post,
+				.child_keys = _child_keys,
+				.child_state_change = _child_state_change,
+				.child_updown = _child_updown,
+				.child_rekey = _child_rekey,
+				.narrow = _narrow,
+			},
+			.destroy = _destroy,
+		},
+	);
+
+	return &(this->public);
+}
diff --git a/src/libcharon/plugins/auth_els/auth_els_ike.h b/src/libcharon/plugins/auth_els/auth_els_ike.h
new file mode 100644
index 000000000..39e53c09e
--- /dev/null
+++ b/src/libcharon/plugins/auth_els/auth_els_ike.h
@@ -0,0 +1,42 @@
+/* Copyright (C) 2019-2020 Marvell */
+
+/**
+ * @defgroup auth_els_ike auth_els_ike
+ * @{ @ingroup auth_els
+ */
+
+#ifndef AUTH_ELS_IKE_H_
+#define AUTH_ELS_IKE_H_
+
+#include <collections/hashtable.h>
+#include <sa/ike_sa.h>
+#include <daemon.h>
+
+typedef struct auth_els_ike_t auth_els_ike_t;
+/**
+ * Listener to synchronize IKE_SAs.
+ */
+struct auth_els_ike_t {
+
+	/**
+	 * Implements bus listener interface.
+	 */
+	listener_t listener;
+
+	/**
+	 * Destroy a auth_els_ike_t.
+	 */
+	void (*destroy)(auth_els_ike_t *this);
+
+};
+
+/**
+ * Create a auth_els_ike instance.
+ *
+ * @param cache			message cache
+ * @param cache			List of rport sockets
+ * @return				IKE listener
+ */
+auth_els_ike_t *auth_els_ike_create();
+
+#endif /** AUTH_ELS_IKE_ @}*/
diff --git a/src/libcharon/plugins/auth_els/auth_els_kernel_fc_sp.c b/src/libcharon/plugins/auth_els/auth_els_kernel_fc_sp.c
new file mode 100644
index 000000000..3d3544e3f
--- /dev/null
+++ b/src/libcharon/plugins/auth_els/auth_els_kernel_fc_sp.c
@@ -0,0 +1,235 @@
+/* Copyright (C) 2019-2020 Marvell */
+
+#include "auth_els_kernel_fc_sp.h"
+
+#include <collections/hashtable.h>
+#include <collections/linked_list.h>
+#include <processing/jobs/delete_ike_sa_job.h>
+#include <threading/rwlock.h>
+#include <threading/mutex.h>
+#include <daemon.h>
+
+#include "auth_els_utils.h"
+
+#include <errno.h>
+#include <linux/xfrm.h>
+#include <utils/debug.h>
+#include <utils/chunk.h>
+
+typedef struct private_auth_els_kernel_fc_sp_t private_auth_els_kernel_fc_sp_t;
+
+/**
+ * Private variables and functions of auth_els kernel fc_sp instance.
+ */
+struct private_auth_els_kernel_fc_sp_t {
+
+	/**
+	 * Public auth_els_kernel_fc_sp interface.
+	 */
+	auth_els_kernel_fc_sp_t public;
+
+	/**
+	 * RNG used for SPI generation.
+	 */
+	rng_t *rng;
+	/**
+	 * Lock to access the RNG instance and the callback for getting spi
+	 */
+	rwlock_t *spi_lock;
+};
+
+
+METHOD(kernel_fc_sp_t, get_features, kernel_feature_t,
+	private_auth_els_kernel_fc_sp_t *this)
+{
+	DBG2 (DBG_CFG, "auth_els - auth_els_kernel_fc_sp - get_features callback, ignoring");
+	return KERNEL_POLICY_SPI;
+}
+
+METHOD(kernel_fc_sp_t, get_spi, status_t,
+	private_auth_els_kernel_fc_sp_t *this, host_t *src, host_t *dst,
+	uint8_t protocol, uint32_t *spi)
+{
+	DBG_ENTER;
+	
+	bool result = FALSE;
+
+	this->spi_lock->read_lock(this->spi_lock);
+
+	if (!this->rng)
+	{
+		DBG_FATAL ("unable to create RNG");
+		*spi = 0;
+		this->spi_lock->unlock(this->spi_lock);
+		return FAILED;
+	}
+
+	result = this->rng->get_bytes(this->rng, sizeof(uint32_t),
+								  (uint8_t *)spi);
+	if (!result)
+	{
+		DBG_FATAL ("get_spi failed, set to 0");
+		*spi = 0;
+	}
+	this->spi_lock->unlock(this->spi_lock);
+
+	DBG_STD ("src port_number %d dest port_number %d, spi provided: %x", src->get_port(src), dst->get_port(dst), *spi);
+
+	return result ? SUCCESS : FAILED;
+}
+
+METHOD(kernel_fc_sp_t, get_cpi, status_t,
+	private_auth_els_kernel_fc_sp_t *this, host_t *src, host_t *dst,
+	uint16_t *cpi)
+{
+	DBG_ENTER;
+	(void) this;
+	(void) src;
+	(void) dst;
+	(void) cpi;
+	
+	return NOT_SUPPORTED;
+}
+
+METHOD(kernel_fc_sp_t, add_sa, status_t,
+	private_auth_els_kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+	kernel_fc_sp_add_sa_t *data)
+{
+	DBG_ENTER;
+
+	uint32_t key_size;
+	uint16_t remote_port_number;
+	status_t final_status = FAILED;
+
+	key_size = data->enc_key.len - 4;
+
+	if (data->inbound)
+	{
+		remote_port_number = id->src->get_port(id->src);
+	}
+	else
+	{
+		remote_port_number = id->dst->get_port(id->dst);
+	}
+	
+	DBG_STD ("remote_port_number: %d, enc_alg: %N, key_size: %d", 
+				remote_port_number, encryption_algorithm_names, data->enc_alg, key_size);
+	
+	return final_status;
+}
+
+METHOD(kernel_fc_sp_t, query_sa, status_t,
+	private_auth_els_kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+	kernel_fc_sp_query_sa_t *data, uint64_t *bytes, uint64_t *packets,
+	time_t *time)
+{
+	DBG_ENTER;
+	
+	int ret_status = SUCCESS;
+	
+	*bytes = 0;
+	*packets = 0;		// Driver only provides bytes for now.
+	
+	return ret_status;
+}
+
+METHOD(kernel_fc_sp_t, del_sa, status_t,
+		private_auth_els_kernel_fc_sp_t *this,
+		kernel_fc_sp_sa_id_t *id,
+		kernel_fc_sp_del_sa_t *data) 
+{
+	status_t final_status = FAILED;
+	
+	DBG_STD ("start: spi: %x", id->spi);
+	
+	return final_status;
+}
+
+METHOD(kernel_fc_sp_t, update_sa, status_t,
+	private_auth_els_kernel_fc_sp_t *this, kernel_fc_sp_sa_id_t *id,
+	kernel_fc_sp_update_sa_t *data)
+{
+	DBG_ENTER;
+	DBG_STD ("child_sa: me: %d, other: %d", 
+				id->src->get_port(id->src), id->dst->get_port(id->dst));
+	
+	return SUCCESS;
+}
+
+METHOD(kernel_fc_sp_t, add_policy, status_t,
+	private_auth_els_kernel_fc_sp_t *this, kernel_fc_sp_policy_id_t *id,
+	kernel_fc_sp_manage_policy_t *data)
+{
+	DBG_ENTER;
+	return SUCCESS;
+}
+
+METHOD(kernel_fc_sp_t, query_policy, status_t,
+	private_auth_els_kernel_fc_sp_t *this, kernel_fc_sp_policy_id_t *id,
+	kernel_fc_sp_query_policy_t *data, time_t *use_time)
+{
+	DBG_ENTER;
+	return NOT_SUPPORTED;
+}
+
+METHOD(kernel_fc_sp_t, del_policy, status_t,
+	private_auth_els_kernel_fc_sp_t *this, kernel_fc_sp_policy_id_t *id,
+	kernel_fc_sp_manage_policy_t *data)
+{
+	DBG_ENTER;
+	return SUCCESS;
+}
+
+METHOD(kernel_fc_sp_t, bypass_socket, bool,
+	private_auth_els_kernel_fc_sp_t *this, int fd, int family)
+{
+	DBG_ENTER;
+	return TRUE;
+}
+
+METHOD(kernel_fc_sp_t, enable_udp_decap, bool,
+	private_auth_els_kernel_fc_sp_t *this, int fd, int family, uint16_t port)
+{
+	DBG_ENTER;
+	return TRUE;
+}
+
+METHOD(kernel_fc_sp_t, destroy, void,
+	private_auth_els_kernel_fc_sp_t *this)
+{
+	DESTROY_IF(this->rng);
+	DESTROY_IF(this->spi_lock);
+	free(this);
+}
+
+/*
+ * Described in header.
+ */
+auth_els_kernel_fc_sp_t *auth_els_kernel_fc_sp_create()
+{
+	private_auth_els_kernel_fc_sp_t *this;
+
+	INIT(this,
+		.public = {
+			.interface = {
+				.get_features = _get_features,
+				.get_spi = _get_spi,
+				.get_cpi = _get_cpi,
+				.add_sa  = _add_sa,
+				.update_sa = _update_sa,
+				.query_sa = _query_sa,
+				.del_sa = _del_sa,
+				.add_policy = _add_policy,
+				.query_policy = _query_policy,
+				.del_policy = _del_policy,
+				.bypass_socket = _bypass_socket,
+				.enable_udp_decap = _enable_udp_decap,
+				.destroy = _destroy,
+			},
+		},
+		.rng = lib->crypto->create_rng(lib->crypto, RNG_WEAK),
+		.spi_lock = rwlock_create(RWLOCK_TYPE_DEFAULT),
+	);
+
+	return &this->public;
+}
